#
#   When adding new class options, if there is an attribute,
#   to the option, you must add an n_xxxx_exit handler that sets
#   the node's attribute.  See n_whenDef_exit.
#
#	Last Modified: 1999:06:10 15:35:33
#

#from ast import AST
#from generic import GenericASTTraversal
#from util import *
from flconvert import *


def dn(l,n):
	if (l!=""):
		print l+":"
	for i in xrange(0, len(n), 1):
		try:
			print "   %d:%s = %s"%(i, n[i].type, str(n[i].attr))
		except:
			print "   %d:%s"%(i, n[i].type)
	


class FlParseTreeConverter(GenericASTTraversal):
	def __init__(self, ast):
		GenericASTTraversal.__init__(self, ast)
		self.defs = []
		self.defStack = [[]]

	def n_versioninfo(self,node):
		pass

	def n_name(self, node):
		if node[0].type=='{':
			node.attr = ""
		else:
			node.attr = node[0].attr


	def n_type_exit(self, node):
		#dn("type_exit", node)
		if (node[0].type == "{"):
			node.attr = node[1].attr  # { type }
		else:
			node.attr = node[0].attr + " " + node[1].type
	
	def n_callbackDef_exit(self, node):
		#dn("callbackDef_exit", node)
		if (node[1].type == "{"):
			node.attr = node[2].attr
		else:
			node.attr = node[1].attr
	

	def n_user_dataDef_exit(self, node):
		#dn("n_user_dataDef_exit", node)
		node.attr = node[1].attr


	

	def n_labelDef_exit(self, node):
		#dn("n_labelDef_exit", node)
		node.attr = ""
		for n in node:
			if n.type == "string":
				n.attr = n.attr[1:-1]
			if n.type == "ld1" or n.type == "identifier" or n.type == "string":
				if node.attr != "":
					node.attr = node.attr + " "
				node.attr = node.attr  + str(n.attr)



	
	def n_ld1_exit(self, node):
		#dn("n_ld1", node)
		node.attr = ""
		for n in node:
			if hasattr(n, "attr"):
				if node.attr != "":
					node.attr = node.attr + " "
				node.attr = node.attr  +  n.attr
			


	def n_classOpts_exit(self, node):
		#dn("n_classOpts_exit", node)
		node.attr = {}
		for n in node:
				if (n.type == "classOpts1"):
					node.attr.update(n.attr)
				else:
					# this is funky, as if there is just one option
					# it is passed up here as the option type, not as
					# the classOpts1 type.
					if (not n.type == "{" and not n.type == "}"):
						node.attr[n.type] = n.attr


	def n_classOpts1_exit(self, node):
		#dn("n_classOpts1_exit", node)
		node.attr = {}
		for n in node:
			if (n.type == "classOpts1"):
				node.attr.update(n.attr)
			else:
				if (n.type == "identifier"):
					node.attr[n.attr]=None
				else:
					if n.type == 'codeDef':
						try:
							node.attr['codeDef'].append(n.attr[1:-1])
						except:
							node.attr['codeDef'] = [ n.attr[1:-1] ]
					else:
						try:
							node.attr[n.type]=n.attr
						except:
							node.attr[n.type]=None
	
	def n_xywhDef(self, node):
		node.attr = ( node[2].attr, node[3].attr, node[4].attr, node[5].attr  )

	def n_whenDef_exit(self, node):
		#dn( "n_whenDef_exit", node)
		node.attr = node[1].attrA

	def n_typeDef_exit(self, node):
		#dn( "n_typeDef_exit", node)
		if node[1].type == "identifier":
			node.attr = node[1].attr
		else:
			node.attr = node[2].attr[1:-1]

	def n_stepDef_exit(self, node):
		#dn( "n_stepDef_exit", node)
		node.attr = node[1].attr



	def n_boxDef_exit(self, node):
		#dn( "n_boxDef_exit", node)
		node.attr = node[1].attr

	def n_down_boxDef_exit(self, node):
		#dn( "n_down_boxDef_exit", node)
		node.attr = node[1].attr

	def n_labeltypeDef_exit(self, node):
		node.attr = node[1].attr

	def n_labelsizeDef_exit(self, node):
		node.attr = node[1].attr

	def n_labelfontDef_exit(self, node):
		node.attr = node[1].attr

	def n_labelcolorDef_exit(self, node):
		node.attr = node[1].attr

	def n_alignDef_exit(self, node):
		node.attr = node[1].attr

	def n_colorDef_exit(self, node):
		node.attr = node[1].attr

	def n_selection_colorDef_exit(self, node):
		node.attr = node[1].attr

	def n_shortcutDef_exit(self, node):
		node.attr = node[1].attr

			
	def n_classDef(self, node):
		node.attr = node[1].attr
		
	def n_inputParams_exit(self, node):
		#dn( "n_inputParams_exit", node)
		node.attr = []
		if (len(node)) == 3:
			if node[1].type=="identifier":
				# swap order in following if you want [ '', 'ident']
				# and in n_inputParams1_exit
				node.attr = [ [ node[1].attr, ''] ]
			else:
				node.attr = node[1].attr

	def n_inputParams1_exit(self, node):
		#dn("n_inputParams1_exit", node)
		if len(node)==2:
			node.attr = [ [node[0].attr, node[1].attr] ]
		else:
			node.attr = []
			for n in [ node[0], node[2]]:
				if n.type=="identifier":
					# swap order in following if you want [ '', 'ident']
					# and in n_inputParams_exit
					node.attr.append( [ n.attr, '' ] )
				else:
					node.attr = node.attr + n.attr


	def n_codeDef_exit(self, node):
		#dn("n_codeDef_exit", node)
		node.attr = node[2].attr



	def n_objectDef_exit(self, node):
		#dn("n_objectDef_exit", node)
		if node[0].type == "code":
			#code definition
			node.attr = { "type":"code", "options":{} }
			if node[1].type == "identifier":
				node.attr['code'] = node[1].attr
			else:
				node.attr['code'] = node[2].attr[1:-1]
		else:
			# normal gui object definition
			node.attr = node[0].attr
			node.attr['type'] = "gui"
			node.attr['objects']=[]
			if len(node)>=3:
				if  node[2].type=='objectDef' or node[2].type=='objectDefHeader':
					node.attr['objects'] = [node[2].attr]
				else:
					if node[2].type=='objectList':
						node.attr['objects'] = node[2].attr

	def n_objectDefHeader_exit(self, node):
		#dn("n_objectDefHeader_exit",node)
		node.attr = {}
		node.attr['type']="gui"
		node.attr['class']=node[0].attr
		node.attr['name']=node[1].attr
		node.attr['options']=node[2].attr
	
	def n_funcOptions_exit(self, node):
		#dn("n_funcOptions_exit", node)
		if node[1].type == "identifier":
			node.attr = [ [node[1].attr,] ]
		else:
			node.attr = node[1].attr  # funcOptions1

	def n_funcOptions1_exit(self, node):
		#dn("n_funcOptions1_exit", node)
		node.attr = []
		for n in node:
			if n.type == "funcOptions1":
				node.attr = node.attr + n.attr
			else:
				if n.type == "identifier":
					node.attr.append( [n.attr,] )
				else:
					if n.type == "type":
						node.attr.append( ["return_type", n.attr])
		
	def n_funcHeader_exit(self, node):
		#dn("n_funcHeader_exit", node)
		node.attr = {}
		if (node[2].type=="}"): # no func name?
			node.attr['name']=""
			node.attr['inputParams'] = []
			node.attr['options'] = node[3].attr
		else:  # named function
			node.attr['name']=node[2].attr
			node.attr['inputParams'] = node[3].attr
			node.attr['options'] = node[5].attr

	def n_objectList_exit(self, node):
		#dn("n_objectList_exit", node)
		node.attr =[]
		for n in node:
			if (n.type == "objectList"):
				node.attr = node.attr + n.attr
			else:
				node.attr.append(n.attr)

	def n_funcObjectList_exit(self, node):
		#dn("n_funcObjectList_exit", node)
		if node[1].type == "objectDef":
			node.attr  = [node[1].attr]
		else:
			if node[1].type == "objectList":
				node.attr = node[1].attr
			else:
				node.attr = []


	def n_funcdef_exit(self, node):
		#dn("n_funcdef_exit", node)
		fdef = { 'def_type':'func' }
		fdef['objects'] = []
		if node[0].type=="funcHeader":
			fdef.update(node[0].attr)
			fdef['objects']=node[1].attr
		else:
			fdef['name'] = node[2].attr
			fdef['inputParams'] = node[3].attr
			fdef['options'] = node[5].attr
			if len(node)>=9:
				fdef['objects'] = node[7].attr
		#dumpFunc(fdef)	
		#self.defs.append(fdef)
		self.defStack[-1].append(fdef)

	def n_decldef_exit(self, node):
		#dn("decldef_exit", node)
		decl = { 'def_type':'decl', 'code':node[2].attr }
		self.defStack[-1].append(decl)

	def n_def1_exit(self, node):
		#dn("def_exit1", node)
		pass

	def n_def_exit(self, node):
		#dn("def_exit", node)
		pass
		

	def n_baseClassList1_exit(self, node):
		#dn("baseClasSList1_exit", node)
		node.attr = node[0].attr + ", " + node[2].attr

	def n_baseClassList_exit(self, node):
		#dn("baseClasSList_exit", node)
		node.attr = node[1].attr 

	def n_userClassHeader_exit(self, node):
		#dn("userClassHeader_exit", node)
		node.attr = { 'name':node[1].attr }
		for i in range( 0, len(node)):
			if node[i].type == ":":
				node.attr['base']=node[i+1].attr
				break

	def n_userClassDef(self, node):
		self.defStack.append([])

	def n_userClassDef_exit(self, node):
		#dn("userClassDef_exit", node)
		node.attr = node[0].attr
		node.attr['def_type'] = 'class'
		node.attr['objects'] = self.defStack.pop()
		self.defStack[-1].append(node.attr)
	
	def n_def(self, node):
		pass
	

	def getDefs(self):
		if (self.defStack[0] == []):
			self.preorder()
		return self.defStack[0]

		


	

if __name__ == '__main__':
	import sys
	def dump(s):
		sys.stdout.write(s)

	from FlScanner import FlScanner
	from FlParser import FlParser
	from FlPreProcessor import FlPreProcessor
	import cStringIO

	try:
		filename = sys.argv[1]
	except:
		filename = "test.fl"
	f = open(filename)
	input = f.read()

	tempFile = cStringIO.StringIO()

	preProcessor = FlPreProcessor()
	preProcessor.tokenize(input, tempFile)
	input = tempFile.getvalue()

	scanner = FlScanner()
	tokens = scanner.tokenize(input)

	parser = FlParser()
	parseTree =  parser.parse(tokens)
	#dumpAstTree(parseTree)

	codeGen = FlParseTreeConverter(parseTree)
	defs = codeGen.getDefs()

	#print str(defs)
	#print
	#dumpTree(defs)
	print len(codeGen.defStack)
	
	def dd(ddef, sp):
		print sp + str(ddef)
	
	for d in codeGen.defStack:
		dd(d,"")	

	




