# Last Modified: 1999:06:10 14:54:00

#from generic import GenericParser
#from token import Token
#from ast import AST
#from generic import GenericASTBuilder
#
from flconvert import *

class FlParser(GenericASTBuilder):
	def __init__(self):
		GenericASTBuilder.__init__(self, AST, "file")

	def p_expr(self, args):
		'''
			file ::= header1 
			file ::= header1 def

			header ::= header1
			header1 ::= header1 header1
			header1 ::= versioninfo 
			header1 ::=	gridspec 
			header1 ::=	snapspec
			header1 ::= fileSpec 
			header1 ::= do_not_include_H_from_C 

			versioninfo ::= version float
			fileSpecType ::= header_name 
			fileSpecType ::= code_name 
			fileSpec ::= fileSpecType {  . identifier  } 
			fileSpec ::= fileSpecType {  identifier . identifier  } 
			gridspec ::= gridx number 
			gridspec ::= gridy number 
			snapspec ::= snap number

			def ::= def def
			def ::= funcdef
			def ::= decldef
			def ::= userClassDef

			decldef ::= decl { string } funcOptions


			userClassHeader ::= class identifier { }
			userClassHeader ::= class identifier { funcOptions1 }
			userClassHeader ::= class identifier { : baseClassList }
			userClassHeader ::= class identifier { funcOptions1 : baseClassList }

			baseClassList ::= identifier
			baseClassList ::=  { baseClassList1 }
			baseClassList1 ::= identifier
			baseClassList1 ::= identifier , baseClassList1

			userClassDef ::= userClassHeader userClassObjList
			
			userClassObjList ::= { } 
			userClassObjList ::= { def  } 





			type ::= identifier
			type ::= const type
			type ::= type * 
			type ::= type & 
			type ::= { type }

			inputParams ::= ( )
			inputParams ::= ( inputParams1 )
			inputParams1 ::= type 
			inputParams1 ::= type identifier
			inputParams1 ::= inputParams1 , inputParams1
			
			funcOptions1 ::= open
			funcOptions1 ::= selected
			funcOptions1 ::= identifier
			funcOptions1 ::= funcOptions1 funcOptions1 
			funcOptions1 ::= return_type type
			funcOptions ::= { funcOptions1 }
			funcOptions ::= { }

			funcdef ::= funcHeader funcObjectList
			funcHeader ::= Function { identifier inputParams } funcOptions 
			funcHeader ::= Function { } funcOptions 
			funcObjectList ::= { }
			funcObjectList ::= { objectList }

			labelDef ::= label ld1
			labelDef ::= label { string }
			labelDef ::= label { ld1 }
			ld1 ::= identifier
			ld1 ::= float
			ld1 ::= number
			ld1 ::= ld1 ld1
			
			name ::= { }
			name ::= identifier

		

			classOpts ::= { }
			classOpts ::= { classOpts1 }

			classOpts1 ::= classOpts1 classOpts1
			classOpts1 ::= xywhDef
			classOpts1 ::= labelDef
			classOpts1 ::= user_dataDef
			classOpts1 ::= callbackDef
			classOpts1 ::= typeDef
			classOpts1 ::= codeDef
			classOpts1 ::= labeltypeDef
			classOpts1 ::= labelsizeDef
			classOpts1 ::= labelfontDef
			classOpts1 ::= labelcolorDef
			classOpts1 ::= boxDef
			classOpts1 ::= down_boxDef
			classOpts1 ::= classDef
			classOpts1 ::= alignDef
			classOpts1 ::= colorDef
			classOpts1 ::= selection_colorDef
			classOpts1 ::= whenDef
			classOpts1 ::= minimumDef
			classOpts1 ::= maximumDef
			classOpts1 ::= stepDef
			classOpts1 ::= selected
			classOpts1 ::= open
			classOpts1 ::= identifier
			classOpts1 ::= valueDef
			classOpts1 ::= shortcutDef

			user_dataDef ::= user_data type
			callbackDef ::= callback identifier
			callbackDef ::= callback { identifier }
			xywhDef ::= xywh { number number number number }	
			boxDef ::= box identifier
			down_boxDef ::= down_box identifier
			shortcutDef ::= shortcut hexadecimal
			typeDef ::= objectType identifier
			typeDef ::= objectType { string }
			labeltypeDef ::= labeltype identifier
			labelsizeDef ::= labelsize number
			labelfontDef ::= labelfont number
			labelcolorDef ::= labelcolor number
			alignDef ::= align number
			colorDef ::= color number
			selection_colorDef ::= selection_color number
			classDef ::= class identifier
			whenDef ::= when number
			minimumDef ::= minimum number
			maximumDef ::= maximum number
			stepDef ::= step float
			stepDef ::= step number
			valueDef ::= value float
			valueDef ::= value number

			codeDef ::= codeDefHeader identifier
			codeDef ::= codeDefHeader { string }

	
			
			objectList ::= objectDef
			objectList ::= objectList objectDef

			objectDef ::= objectDefHeader
			objectDef ::= objectDefHeader { }
			objectDef ::= objectDefHeader { objectList }
			objectDef ::= code { string } classOpts
			objectDef ::= code identifier classOpts
			objectDefHeader ::= identifier name classOpts

	


			  

			
			
			
		'''

	def terminal(self, token):
		#
		#  Homogeneous AST.
		#
		rv = AST(token.type)
		rv.attr = token.attr
		return rv

	def nonterminal(self, type, args):
		#
		#  Flatten AST a bit by not making nodes if there's only
		#  one child.
		#
		if len(args) == 1:
			return args[0]
		return GenericASTBuilder.nonterminal(self, type, args)


