#from generic import GenericScanner
#from token import Token
#
from flconvert import *
import re

codeDefRegex = re.compile("code[0-4]?$")


class FlPreProcessor(GenericScanner):

	def __init__(self):
		GenericScanner.__init__(self)
		self.labelingOrCoding = None
		self.blockLabelOrCoding = None

	def default(self, s):
		self.outputFile.write(s)

	def t_whitespace(self, s):
		r' \s+ '
		self.outputFile.write(s)


	def t_be(self, s):
		r'}'
		if self.labelingOrCoding:
			self.labelingOrCoding = None
			self.blockLabelOrCoding = None
			self.outputFile.write('" ')
		self.outputFile.write("}")
	
	def t_bs(self, s):
		r'{'
		self.outputFile.write("{ ")
		if self.labelingOrCoding:
			self.blockLabelOrCoding = 1
			self.outputFile.write('"')



	def t_name(self, s):
		r'  [^\s{}]+ '
		if s=='decl' or s == 'label' or codeDefRegex.match(s) or s == 'type':
			if not self.labelingOrCoding:
				self.labelingOrCoding = 1
				if (s=="type"):
					self.outputFile.write("objectType")
				else:
					self.outputFile.write(s)
			else:
				if not self.blockLabelOrCoding:
					self.outputFile.write('{ "'+s+'" }')
				else:
					self.outputFile.write(s)
		else:
			if self.labelingOrCoding and not self.blockLabelOrCoding:
				self.labelingOrCoding = None
			if (s=="type"):
				self.outputFile.write("objectType")
			else:
				self.outputFile.write(s)



	def	tokenize(self, input, outputFile):
		self.rv = []
		self.outputFile = outputFile
		GenericScanner.tokenize(self, input)
		return self.rv

	

if __name__ == '__main__':
	import sys
	try:
		filename = sys.argv[1]
	except:
		filename = "test.fl"
	f = open(filename)
	input = f.read()
	scanner = FlPreProcessor()
	scanner.tokenize(input, sys.stdout)

